summaryrefslogtreecommitdiffstats
path: root/libraries/googlebenchmark
diff options
context:
space:
mode:
author Lockywolf2023-06-09 10:55:48 +0200
committer Willy Sudiarto Raharjo2023-06-10 09:01:20 +0200
commit2bef5faefd151778fe141d01d0a8c97e7fae73f0 (patch)
treeca7db7afaf9aaf849b3a70abb11b9332f8770e25 /libraries/googlebenchmark
parent858927011062d4557b0e4d0a4eeeaf015832cb85 (diff)
downloadslackbuilds-2bef5faefd151778fe141d01d0a8c97e7fae73f0.tar.gz
libraries/googlebenchmark: Added (Google tiny benchmarking library)
Signed-off-by: bedlam <dave@slackbuilds.org> Signed-off-by: Willy Sudiarto Raharjo <willysr@slackbuilds.org>
Diffstat (limited to 'libraries/googlebenchmark')
-rw-r--r--libraries/googlebenchmark/README5
-rw-r--r--libraries/googlebenchmark/googlebenchmark.SlackBuild119
-rw-r--r--libraries/googlebenchmark/googlebenchmark.info10
-rw-r--r--libraries/googlebenchmark/slack-desc19
4 files changed, 153 insertions, 0 deletions
diff --git a/libraries/googlebenchmark/README b/libraries/googlebenchmark/README
new file mode 100644
index 0000000000..b39143dc76
--- /dev/null
+++ b/libraries/googlebenchmark/README
@@ -0,0 +1,5 @@
+Google microbenchmarking library.
+
+Define a function that executes the code to measure, register it as
+a benchmark function using the BENCHMARK macro, and ensure an
+appropriate main function is available.
diff --git a/libraries/googlebenchmark/googlebenchmark.SlackBuild b/libraries/googlebenchmark/googlebenchmark.SlackBuild
new file mode 100644
index 0000000000..fdfa6c16b8
--- /dev/null
+++ b/libraries/googlebenchmark/googlebenchmark.SlackBuild
@@ -0,0 +1,119 @@
+#!/bin/bash
+
+# Slackware build script for googlebenchmark
+
+# Copyright Lockywolf 2023
+# All rights reserved.
+#
+# Redistribution and use of this script, with or without modification, is
+# permitted provided that the following conditions are met:
+#
+# 1. Redistributions of this script must retain the above copyright
+# notice, this list of conditions and the following disclaimer.
+#
+# THIS SOFTWARE IS PROVIDED BY THE AUTHOR "AS IS" AND ANY EXPRESS OR IMPLIED
+# WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
+# MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO
+# EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
+# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO,
+# PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS;
+# OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
+# WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
+# OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF
+# ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+
+cd $(dirname $0) ; CWD=$(pwd)
+
+PRGNAM=googlebenchmark
+VERSION=${VERSION:-1.8.0}
+BUILD=${BUILD:-1}
+TAG=${TAG:-_SBo}
+PKGTYPE=${PKGTYPE:-tgz}
+
+if [ -z "$ARCH" ]; then
+ case "$( uname -m )" in
+ i?86) ARCH=i586 ;;
+ arm*) ARCH=arm ;;
+ *) ARCH=$( uname -m ) ;;
+ esac
+fi
+
+# If the variable PRINT_PACKAGE_NAME is set, then this script will report what
+# the name of the created package would be, and then exit. This information
+# could be useful to other scripts.
+if [ ! -z "${PRINT_PACKAGE_NAME}" ]; then
+ echo "$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE"
+ exit 0
+fi
+
+TMP=${TMP:-/tmp/SBo}
+PKG=$TMP/package-$PRGNAM
+OUTPUT=${OUTPUT:-/tmp}
+
+if [ "$ARCH" = "i586" ]; then
+ SLKCFLAGS="-O2 -march=i586 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [ "$ARCH" = "i686" ]; then
+ SLKCFLAGS="-O2 -march=i686 -mtune=i686"
+ LIBDIRSUFFIX=""
+elif [[ "$ARCH" = "x86_64" || "$ARCH" = "aarch64" ]]; then
+ SLKCFLAGS="-O2 -fPIC"
+ LIBDIRSUFFIX="64"
+else
+ SLKCFLAGS="-O2"
+ LIBDIRSUFFIX=""
+fi
+
+set -e
+
+rm -rf $PKG
+mkdir -p $TMP $PKG $OUTPUT
+cd $TMP
+TARNAM=benchmark
+rm -rf $TARNAM-$VERSION
+tar xvf $CWD/$TARNAM-$VERSION.tar.gz
+cd $TARNAM-$VERSION
+chown -R root:root .
+find -L . \
+ \( -perm 777 -o -perm 775 -o -perm 750 -o -perm 711 -o -perm 555 \
+ -o -perm 511 \) -exec chmod 755 {} \; -o \
+ \( -perm 666 -o -perm 664 -o -perm 640 -o -perm 600 -o -perm 444 \
+ -o -perm 440 -o -perm 400 \) -exec chmod 644 {} \;
+
+mkdir -p build
+cd build
+ cmake \
+ -DCMAKE_C_FLAGS:STRING="$SLKCFLAGS" \
+ -DCMAKE_CXX_FLAGS:STRING="$SLKCFLAGS -fpermissive -fno-strict-aliasing -Wno-error=lto-type-mismatch -std=c++11 -lgtest -lgtest_main" \
+ -DCMAKE_INSTALL_PREFIX=/usr \
+ -DCMAKE_INSTALL_LIBDIR=lib${LIBDIRSUFFIX} \
+ -DLIB_SUFFIX=${LIBDIRSUFFIX} \
+ -DMAN_INSTALL_DIR=/usr/man \
+ -DBENCHMARK_ENABLE_EXCEPTIONS=ON \
+ -DBENCHMARK_ENABLE_GTEST_TESTS=OFF \
+ -DBENCHMARK_ENABLE_LTO=ON \
+ -DBENCHMARK_ENABLE_ASSEMBLY_TESTS=OFF \
+ -DCMAKE_BUILD_TYPE=Release ..
+ make
+ make install/strip DESTDIR=$PKG
+cd ..
+
+rm -f $PKG/{,usr/}lib${LIBDIRSUFFIX}/*.la
+
+find $PKG -print0 | xargs -0 file | grep -e "executable" -e "shared object" | grep ELF \
+ | cut -f 1 -d : | xargs strip --strip-unneeded 2> /dev/null || true
+
+
+mkdir -p $PKG/usr/doc/$PRGNAM-$VERSION
+cp -a \
+ AUTHORS CONTRIBUTORS LICENSE README.md docs \
+ $PKG/usr/doc/$PRGNAM-$VERSION
+mv $PKG/usr/share/doc/* $PKG/usr/doc/$PRGNAM-$VERSION
+rm -rf $PKG/usr/share
+cat $CWD/$PRGNAM.SlackBuild > $PKG/usr/doc/$PRGNAM-$VERSION/$PRGNAM.SlackBuild
+
+mkdir -p $PKG/install
+cat $CWD/slack-desc > $PKG/install/slack-desc
+
+cd $PKG
+/sbin/makepkg -l y -c n $OUTPUT/$PRGNAM-$VERSION-$ARCH-$BUILD$TAG.$PKGTYPE
diff --git a/libraries/googlebenchmark/googlebenchmark.info b/libraries/googlebenchmark/googlebenchmark.info
new file mode 100644
index 0000000000..5802cdb767
--- /dev/null
+++ b/libraries/googlebenchmark/googlebenchmark.info
@@ -0,0 +1,10 @@
+PRGNAM="googlebenchmark"
+VERSION="1.8.0"
+HOMEPAGE="https://github.com/google/benchmark/"
+DOWNLOAD="https://github.com/google/benchmark/archive/v1.8.0/benchmark-1.8.0.tar.gz"
+MD5SUM="8ddf8571d3f6198d37852bcbd964f817"
+DOWNLOAD_x86_64=""
+MD5SUM_x86_64=""
+REQUIRES="gtest gflags"
+MAINTAINER="Lockywolf"
+EMAIL="for_sbo.googlebenchmark_2023-05-28@lockywolf.net"
diff --git a/libraries/googlebenchmark/slack-desc b/libraries/googlebenchmark/slack-desc
new file mode 100644
index 0000000000..83bdb8fa68
--- /dev/null
+++ b/libraries/googlebenchmark/slack-desc
@@ -0,0 +1,19 @@
+# HOW TO EDIT THIS FILE:
+# The "handy ruler" below makes it easier to edit a package description.
+# Line up the first '|' above the ':' following the base package name, and
+# the '|' on the right side marks the last column you can put a character in.
+# You must make exactly 11 lines for the formatting to be correct. It's also
+# customary to leave one space after the ':' except on otherwise blank lines.
+
+ |-----handy-ruler------------------------------------------------------|
+googlebenchmark: googlebenchmark (Google tiny benchmarking library)
+googlebenchmark:
+googlebenchmark: A library for measuring program's performance.
+googlebenchmark: Define a function that executes the code to measure, register it as
+googlebenchmark: a benchmark function using the BENCHMARK macro, and ensure an
+googlebenchmark: appropriate main function is available.
+googlebenchmark:
+googlebenchmark:
+googlebenchmark:
+googlebenchmark:
+googlebenchmark: